#ifndef CUTSEMULATOR_h
#define CUTSEMULATOR_h
/*****************************/
/* class to emulate the cuts */
/*****************************/
//----------------
#include "Moses.h"
//----------------
#include "parameters.h"
#include "mosesParticle.h"


using namespace std;

namespace Moses1 {

class cutsEmulator {
	public:
		cutsEmulator();
		virtual ~cutsEmulator();
		
		virtual void setMinCosTheta(double s, double y, runParameters &runPrm);

		virtual double getModifiedCosThetaIntegral(double s, double y, runParameters &runPrm);
		virtual double getModifiedCosThetaIntegral(double s, double y, runParameters &runPrm, int forwardBackward);
		virtual double getModifiedCosThetaIntegral(double s, double y, runParameters &runPrm, int forwardBackward, int SorA);

		virtual double getMinCosTheta(double s, double y, runParameters &runPrm);

	private:
		double m_pi;
		vector<double> m_cosThetaStar;
		vector<bool> m_valid; 
		double m_cosThetaStar_min;
};

}
#endif
