#ifndef MOSESJETRECORD_h
#define MOSESJETRECORD_h

#include "Basics.h"
#include "Event.h"
#include "Analysis.h"
#include "mosesCommon.h"

using namespace std;
using namespace Pythia8;

namespace Moses1 {


class mosesClusterJetRecord
{
    public:
		mosesClusterJetRecord(string name, TFile* file);
		~mosesClusterJetRecord();
	
		string getName() { return m_name; }
		
		bool fillRecordTree();
		bool writeRecordTree();
		bool clearJetRecord();
		bool fillJetRecord( Event& event, ClusterJet* clusterJet );
		
		bool isHardProcessStatus(int absStatus);
		void findHardProcessJets(Event& event, ClusterJet* clusterJet);


    private:
		void initialize(string name, TFile* file);

		string m_name;
		
		TDirectory* m_dir;
					
		TTree* m_jetDataTree;

		vector<bool> m_hardProcessJets;
		
		vector<int>* m_isHardProcess;
		
		vector<double>* m_p0;
		vector<double>* m_px;
		vector<double>* m_py;
		vector<double>* m_pz;
};



class mosesCellJetRecord : public Vec4
{
    public:
		mosesCellJetRecord(string name, TFile* file);
		~mosesCellJetRecord();
	
		string getName() {return m_name;}
		
		bool fillRecordTree();
		bool writeRecordTree();
		bool clearJetRecord();
		bool fillJetRecord( Event& event, CellJet* cellJet );

    private:
		void initialize(string name, TFile* file);

		string m_name;
	
		TDirectory* m_dir;
					
		TTree* m_jetDataTree;

		vector<double>* m_m0;
		vector<double>* m_p0Massless;
		vector<double>* m_pxMassless;
 		vector<double>* m_pyMassless;
		vector<double>* m_pzMassless;
		vector<double>* m_eT;
		vector<double>* m_etaCenter;
		vector<double>* m_phiCenter;
		vector<double>* m_etaWeighted;
		vector<double>* m_phiWeighted;
		vector<int>*    m_multiplicity;
		
		vector<double>* m_p0;
		vector<double>* m_px;
		vector<double>* m_py;
		vector<double>* m_pz;
};



}

#endif
